/***************************************************************************
  additional_functions.cpp  -  description
  -------------------
begin                : Mon Dec 3 2001
copyright            : (C) 2001 by Denis Lackovic
email                : delacko@fly.srk.fer.hr
 ***************************************************************************/

#include <qfile.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qtextstream.h>   	
#include <qtextcodec.h>   	
#include <qmessagebox.h>   	
#include <iostream.h>   	
#include "additional_functions.h"
#include "db_2_gui.h"

void DictDescription::setTableName(QString tn){
	tableName=tn;
}
void DictDescription::setShortTableName(QString stn){
	shortTableName=stn;
}
void DictDescription::setDictName(QString dn){
	dictName=dn;
}
void DictDescription::setDictServer(QString ds){
	dictServer=ds;
}
void DictDescription::setDictServerPort(QString dspo){
	dictServerPort=dspo;
}
void DictDescription::setDictServerDatabase(QString dsd){
	dictServerDatabaseName=dsd;
}
void DictDescription::setDictServerUserName(QString dsun){
	dictServerUserName=dsun;
}
void DictDescription::setDictServerPassword(QString dsp){
	dictServerPassword=dsp;
}
void DictDescription::setNumOfPluralForms(QString nOPF){
	numOfPluralForms=nOPF;
}
void DictDescription::setPluralExpression(QString pE){
	pluralExpression=pE;
}

QString DictDescription::getTableName(){
	return tableName;
}
QString DictDescription::getShortTableName(){
	return shortTableName;
}
QString DictDescription::getDictName(){
	return dictName;
}
QString DictDescription::getDictServer(){
	return dictServer;
}
QString DictDescription::getDictServerPort(){
	return dictServerPort;
}
QString DictDescription::getDictServerDatabase(){
	return dictServerDatabaseName;
}
QString DictDescription::getDictServerUserName(){
	return dictServerUserName;
}
QString DictDescription::getDictServerPassword(){
	return dictServerPassword;
}
QString DictDescription::getNumOfPluralForms(){
	return numOfPluralForms;
}
QString DictDescription::getPluralExpression(){
	return pluralExpression;
}



void Cfg::setUserName(QString un){
	userName=un;
}
void Cfg::setUserEmail(QString ue){
	userEmail=ue;
}
void Cfg::setLanguageTeam(QString lt){
	languageTeam=lt;
}
void Cfg::setLanguageTeamEmail(QString lte){
	languageTeamEmail=lte;
}
void Cfg::setImportEncoding(QString ie){
	importEnc=ie;
}
void Cfg::setExportEncoding(QString ee){
	exportEnc=ee;
}
QString Cfg::getUserName(){
	return userName;
}
QString Cfg::getUserEmail(){
	return userEmail;
}
QString Cfg::getLanguageTeam(){
	return languageTeam;
}
QString Cfg::getLanguageTeamEmail(){
	return languageTeamEmail;
}
QString Cfg::getImportEncoding(){
	return importEnc;
}
QString Cfg::getExportEncoding(){
	return exportEnc;
}




void get_dictionaries(QString confName, QList<DictType> &dTypes, DictType & curDType, DictDescription & curDict, Cfg &cfg){
	QFile conf(confName);


	if ( conf.open(IO_ReadOnly) ) {
		QTextStream t( &conf );
		QTextCodec *codec;
		codec=QTextCodec::codecForName("utf-8");
		t.setCodec(codec);

		QString s;
		int state=1;


		QRegExp minus("-");
		QRegExp space(" ");
		DictType *dt = new DictType;
		DictDescription *dd= new DictDescription;
		QString fd,ind,hlp;
		QStringList b1,b2,tn;
	//	int i;


		while ( !t.eof() ) {     
			s = t.readLine();

			if (state==1){
				if (s.find("DICTIONARY_TYPES")!=-1){
					state=2;
				}
				else if (s.find("DICTIONARIES")!=-1){
					state=4;
				}
				else if (s.find("USER_NAME")!=-1){
					s.replace(QRegExp(".*USER_NAME[ \t]*=[ \t]*"),"");
					cfg.setUserName(s);
					
				}
				else if (s.find("E_MAIL")!=-1){
					s.replace(QRegExp(".*E_MAIL[ \t]*=[ \t]*"),"");
					cfg.setUserEmail(s);
				}
				else if (s.find("LANGUAGE_TEAM")!=-1){
					s.replace(QRegExp(".*LANGUAGE_TEAM[ \t]*=[ \t]*"),"");
					cfg.setLanguageTeam(s);
				}
				else if (s.find("TEAM_EMAIL")!=-1){
					s.replace(QRegExp(".*TEAM_EMAIL[ \t]*=[ \t]*"),"");
					cfg.setLanguageTeamEmail(s);
				}
				else if (s.find("IMPORT_ENCODING")!=-1){
					s.replace(QRegExp(".*IMPORT_ENCODING[ \t]*=[ \t]*"),"");
					cfg.setImportEncoding(s);
					
				}
				else if (s.find("EXPORT_ENCODING")!=-1){
					s.replace(QRegExp(".*EXPORT_ENCODING[ \t]*=[ \t]*"),"");
					cfg.setExportEncoding(s);
					
				}
			}
			else if(state==2){
				if (s.find("TYPE_NAME")!=-1){
					dt->typeName=s.replace(QRegExp("[ \t]*TYPE_NAME[ \t]*=[ \t]*"),"");
					state=3;
				}
				else if (s.find("END_DICTIONARY_TYPES")!=-1){
					state=1;
				}
			}
			else if(state==3){
				if (s.find("FIELD")!=-1){
					fd=s.replace(QRegExp("[ \t]*FIELD[ \t]*=[ \t]*"),"");
					b1=b1.split("|",fd,TRUE);
					b2=b2.split(":",b1[0]);
					
					dt->colNames.append(b2[0]);
					dt->colTypes.append(b2[1]);
					
					if (b1[1].length()!=0){
						dt->pKey.append(b1[1]);
					}
					else{
						dt->pKey.append("");
					}
				}
				else if (s.find("END_TYPE")!=-1){
					dTypes.append(new DictType(dt->typeName,dt->colNames,dt->colTypes,dt->pKey,dt->dicts));
					dt->clear();
					state=2;
				}
			}
			else if(state==4){
				if (s.find("DICT_CONF")!=-1){
					fd=s.replace(QRegExp("[ \t]*DICT_CONF[ \t]*=[ \t]*"),"");
					b1=b1.split("|||",fd,TRUE);
					dd->setDictName(b1[0]);
					hlp=b1[0]+b1[1];
					hlp.replace(minus,"");
					dd->setTableName(hlp);
					
					tn=tn.split("-",b1[0]);
					hlp=tn[0].mid(0,1);
					hlp+=tn[1].mid(0,1);
					hlp+=b1[1].mid(0,1);
					dd->setShortTableName(hlp);
					
					b2=b2.split(":",b1[2],TRUE);
					
					dd->setDictServer(b2[0]);
					dd->setDictServerPort(b2[1]);
					dd->setDictServerDatabase(b2[2]);
					dd->setDictServerUserName(b2[3]);
					dd->setDictServerPassword(b2[4]);

					
					//now searching for number of plural forms and plural expression
					b2=b2.split("---",b1[3],TRUE);
					dd->setNumOfPluralForms(b2[0]);
					dd->setPluralExpression(b2[1]);

					DictType *it;
					for(it=dTypes.first(); it!=0;it=dTypes.next()){
						if (it->typeName==b1[1]){


							it->dicts.append(new DictDescription(dd->getTableName(),dd->getDictName(),dd->getDictServer(),dd->getDictServerPort(),dd->getDictServerDatabase(),dd->getDictServerUserName(),dd->getDictServerPassword(),dd->getShortTableName(),dd->getNumOfPluralForms(),dd->getPluralExpression()));
							break;
						}
					}
					//dictionaries.append(new DictDescription(dd->tableName,dd->dictName,dd->type,dd->dictServer));
				}
				else if (s.find("DICT_DEFAULT")!=-1){
					fd=s.replace(QRegExp("[ \t]*DICT_DEFAULT[ \t]*=[ \t]*"),"");
					b1=b1.split("|||",fd,TRUE);
					curDict.setDictName(b1[0]);
					hlp=b1[0]+b1[1];
					hlp.replace(minus,"");
					curDict.setTableName(hlp);
					
					tn=tn.split("-",b1[0]);
					hlp=tn[0].mid(0,1);
					hlp+=tn[1].mid(0,1);
					hlp+=b1[1].mid(0,1);
					curDict.setShortTableName(hlp);
					
					
					b2=b2.split(":",b1[2],TRUE);
					curDict.setDictServer(b2[0]);
					curDict.setDictServerPort(b2[1]);
					curDict.setDictServerDatabase(b2[2]);
					curDict.setDictServerUserName(b2[3]);
					curDict.setDictServerPassword(b2[4]);
//					curDict.tableName=b1[0]+b1[1];
//					curDict.tableName.replace(minus,"");

					b2=b2.split("---",b1[3],TRUE);
					curDict.setNumOfPluralForms(b2[0]);
					curDict.setPluralExpression(b2[1]);

					DictType *it;
					for(it=dTypes.first(); it!=0;it=dTypes.next()){
						if (it->typeName==b1[1]){
							curDType=*it;
						}
					}
					
				}
				else if (s.find("END_DICTIONARIES")!=-1){
					state=1;
				}
			}


		}
	}
} 

void save_configuration(QString confName, QList<DictType> &dTypes, DictType & curDType, DictDescription & curDict, Cfg &cfg){
	QFile conf(confName);

	if ( conf.open(IO_WriteOnly) ) {

		int i;
		QString toWrite;
		toWrite="DICTIONARY_TYPES\n";

		DictType *it;
		for(it=dTypes.first(); it!=0; it=dTypes.next(),i++){
			toWrite+="\tTYPE_NAME="+it->typeName+"\n";
			for(i=0; i < it->colNames.count(); i++){
				toWrite+="\t\tFIELD="+it->colNames[i]+":"+it->colTypes[i]+"|";
				toWrite+=it->pKey[i]+"\n";
			}
			toWrite+="\tEND_TYPE\n";
		}

		toWrite+="END_DICTIONARY_TYPES\n\n";

		toWrite+="DICTIONARIES\n";
	
		i=0;	
		DictDescription *di;
		for(it=dTypes.first(); it!=0; it=dTypes.next()){
			for(QListIterator<DictDescription> dd(it->dicts); dd.current(); ++dd,i++){
				di=dd.current();
				
				toWrite+="\tDICT_CONF="+di->getDictName()+"|||"+it->typeName+"|||";
				toWrite+=di->getDictServer()+":"+di->getDictServerPort()+":"+di->getDictServerDatabase()+":"+ di->getDictServerUserName()+":"+di->getDictServerPassword()+":|||"+di->getNumOfPluralForms()+"---"+di->getPluralExpression()+"\n";
				if(di->getDictName()==curDict.getDictName()){
					toWrite+="\tDICT_DEFAULT="+di->getDictName()+"|||"+it->typeName+"|||";
					toWrite+=di->getDictServer()+":"+di->getDictServerPort()+":"+di->getDictServerDatabase()+":"+ di->getDictServerUserName()+":"+di->getDictServerPassword()+":|||"+di->getNumOfPluralForms()+"---"+di->getPluralExpression()+	"\n";
				}
			}
		}
		toWrite+="\nEND_DICTIONARIES\n\n";
		toWrite+="USER_NAME="+cfg.getUserName()+"\n";
		toWrite+="E_MAIL="+cfg.getUserEmail()+"\n";
		toWrite+="LANGUAGE_TEAM="+cfg.getLanguageTeam()+"\n";
		toWrite+="TEAM_EMAIL="+cfg.getLanguageTeamEmail()+"\n";
		toWrite+="IMPORT_ENCODING="+cfg.getImportEncoding()+"\n";
		toWrite+="EXPORT_ENCODING="+cfg.getExportEncoding()+"\n";

		cout <<"spremam u konf file un: "+cfg.getUserName()+"\n";

			conf.writeBlock(toWrite.latin1(),toWrite.length());
	}
	else {
		QMessageBox::information( 0, "Error opening configuration file",   "I cannot write to configuration file " + confName, QMessageBox::Ok );                                    			
		return;
	}
//	return 0;

}
int add_dictionary(QString confName,DictDescription newDict){
	QFile conf(confName);

	if ( conf.open(IO_WriteOnly) ) {

		QString toWrite;
		toWrite="DICTIONAR_TYPES";
		//dict_field *tmp;
		QString fields="";
		//int i=0;
	}
	else {
		QMessageBox::information( 0, "Error opening configuration file",   "I cannot read from configuration file " + newDict.getDictName(), QMessageBox::Ok );                                    			
		return -1;
	}
	return 0;
}

void set_default_dictionary(QString confName,DictDescription &curDict){
}

