/***************************************************************************
  additional_functions.h  -  description
  -------------------
begin                : Mon Dec 3 2001
copyright            : (C) 2001 by Denis Lackovic
email                : delacko@fly.srk.fer.hr
 ***************************************************************************/

#include <qfile.h>
#include <qstring.h>
#include <qlist.h>
#include <qstringlist.h>
#include <qtextstream.h>
#include <iostream.h>

#ifndef ADITIONAL_H
#define ADITIONAL_H

class Cfg{
	public:

		void setUserName(QString un);
		void setImportEncoding(QString ie);
		void setExportEncoding(QString ie);
		void setUserEmail(QString ue);
		void setLanguageTeam(QString lt);
		void setLanguageTeamEmail(QString lte);
		QString getUserName();
		QString getUserEmail();
		QString getLanguageTeam();
		QString getLanguageTeamEmail();
		QString getImportEncoding();
		QString getExportEncoding();

		
	private:
		QString userName;
		QString userEmail;
		QString languageTeam;
		QString languageTeamEmail;
		QString importEnc;
		QString exportEnc;
};

class DictDescription {
	private:
		QString tableName;
		QString dictName;
		QString shortTableName;
		QString dictServer;
		QString dictServerPort;
		QString dictServerDatabaseName;
		QString dictServerUserName;
		QString dictServerPassword;
		QString numOfPluralForms;
		QString pluralExpression;

	public:
		DictDescription(){}
		DictDescription(QString tN, QString dN, QString dS,QString dspo, QString dsdn,QString dsun,QString dspa,  QString stn, QString nOPF, QString pE){
			tableName=tN;
			dictName=dN;
			dictServer=dS;
			dictServerPort=dspo;
			dictServerDatabaseName=dsdn;
			dictServerUserName=dsun;
			dictServerPassword=dspa;
			shortTableName=stn;
			numOfPluralForms=nOPF;
			pluralExpression=pE;
		}
		~DictDescription(){};
		void operator= (const DictDescription  & dd){
			tableName=dd.tableName;
			dictName=dd.dictName;
			dictServer=dd.dictServer;
			dictServerPort=dd.dictServerPort;
			dictServerDatabaseName=dd.dictServerDatabaseName;
			dictServerUserName=dd.dictServerUserName;
			dictServerPassword=dd.dictServerPassword;
			shortTableName=dd.shortTableName;
			numOfPluralForms=dd.numOfPluralForms;
			pluralExpression=dd.pluralExpression;
		}


		void setTableName(QString tn);
		void setShortTableName(QString tn);
		void setDictName(QString dn);
		void setDictServer(QString ds);
		void setDictServerPort(QString dspo);
		void setDictServerDatabase(QString dsd);
		void setDictServerUserName(QString dsun);
		void setDictServerPassword(QString dspa);
		void setNumOfPluralForms(QString nOPF);
		void setPluralExpression(QString pE);
		QString getTableName();
		QString getShortTableName();
		QString getDictName();
		QString getDictServer();
		QString getDictServerPort();
		QString getDictServerDatabase();
		QString getDictServerUserName();
		QString getDictServerPassword();
		QString getNumOfPluralForms();
		QString getPluralExpression();
		
};   	

class DictType {
	public:
		QString typeName;
		QStringList colNames;
		QStringList colTypes;
		//we group all dictionaries of one type
		QList<DictDescription> dicts;
		//used to store inforation about indexes and primary keys on a table
		QStringList pKey;

//		DictType(const DictType &dt){}
		DictType(){}
		DictType(QString tN, QStringList cN, QStringList cT, QStringList i,QList<DictDescription> d){
			typeName=tN;
			colNames=cN;
			colTypes=cT;
			pKey=i;
			dicts=d;
		}
		~DictType(){}
		void operator= (const DictType &dt){
			typeName=dt.typeName;
//cout <<"pokusavam okinuti" <<typeName<<endl;
			colNames=dt.colNames;
			colTypes=dt.colTypes;
			pKey=dt.pKey;
			dicts=dt.dicts;
		}
		void clear(){
			typeName="";
			colNames.clear();
			colTypes.clear();
			pKey.clear();
			dicts.clear();

		}
				
};



//void get_dictionaries(QString confName,QString path,QStringList & dictionaries, QString & dict_default);
void get_dictionaries(QString confName,QList<DictType> &dTypes, DictType & curDType, DictDescription & dictDefault,Cfg & conf);
void save_configuration(QString confName,QList<DictType> &dTypes, DictType & curDType, DictDescription & dictDefault,Cfg & conf);
//int add_dictionary(QString confName,QString path,QString dictName);
int add_dictionary(QString confName,DictDescription newDict);


void set_default_dictionary(QString confName, DictDescription & dictDefault);

#endif
