/***************************************************************************
  dialog_create_dictionary.cpp  -  description
  -------------------
begin                : Mon Dec 3 2001
copyright            : (C) 2001 by Denis Lackovic
email                : delacko@fly.srk.fer.hr
 ***************************************************************************/


#include <string.h>
#include <stdio.h>


#include <qfile.h>
#include <qstring.h>
#include<iostream.h>
#include <qlineedit.h>
#include <qbutton.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qmessagebox.h>




#include <qlist.h>
#include "create_dictionary.h"
#include "dialog_create_dictionary.h"
#include "dialog_dictionary_layout.h"
#include "additional_functions.h"


void dialog_cd::on_first_lang_changed(){
	QString first=LE_first->text();
	QString second=LE_second->text();
	first.lower();
	second.lower();
	
	QString dictName;
	dictName=first+"-"+second;
	TL_dictionary_name->setText(dictName);
}

void dialog_cd::on_second_lang_changed(){
	QString first=LE_first->text();
	QString second=LE_second->text();
	first.lower();
	second.lower();

	QString dictName;
	dictName=first+"-"+second;
	TL_dictionary_name->setText(dictName);
}

void dialog_cd::on_ok(){
	QString first=LE_first->text();
	QString second=LE_second->text();
	QString type=CB_dictionary_type->currentText();


	
	first.lower();
	second.lower();


	if(first.length()==0){
		QMessageBox::information( this, "Language error",   "You have to name first language.", QMessageBox::Ok );                                    			
		return;
	}
	if( second.length()==0){
		QMessageBox::information( this, "Language error",   "You have to name second language.", QMessageBox::Ok );                                    			
		return;
	}
	if( type.length()==0){
		QMessageBox::information( this, "Error in dictionary type",   "You have to choose dictionary type to be created.", QMessageBox::Ok );                                    			
		return;
	}
	accept();

}


void dialog_cd::on_cd_dictionary_type_changed(const QString &type){
	
	DictType *it;
	for(it=dTypes.first(); it!=0; it=dTypes.next()){
			if(it->typeName==type){
				curDType=*it;
			}
	}

	
	Table_dict_fields->setNumRows(0);
	Table_dict_fields->setNumRows(curDType.colNames.count());

	int i=0;
	QStringList keys;
	for(QStringList::Iterator it=curDType.colNames.begin();it!=curDType.colNames.end(); ++it,i++){
		Table_dict_fields->setText(i,0,*it);
		Table_dict_fields->setText(i,1,curDType.colTypes[i]);
		if (curDType.pKey[i].length()!=0){
			keys=keys.split(",",curDType.pKey[i]);
			for ( QStringList::Iterator it = keys.begin(); it != keys.end(); ++it ) {
				printf( "%s \n", (*it).latin1() );
				if(*it=="Primary key"){
					Table_dict_fields->setText(i,2,*it);
				}
				else {
					QString bu=Table_dict_fields->text(i,3);

					if(bu.length()==0){
						Table_dict_fields->setText(i,3,*it);
					}
					else {
						Table_dict_fields->setText(i,3,bu+","+*it);
					}
				}
			}

		}
	}
}



void dialog_cd::on_create_new_dictionary_type(){
	dialog_dl *layout= new dialog_dl(this);

	if(layout->exec()==1){
			CB_dictionary_type->insertItem(layout->LE_type_name->text(),0);

			int nR=layout->Table_fields->numRows();

			Table_dict_fields->setNumRows(nR);

			int i;
			for(i=0; i<nR; i++){
				Table_dict_fields->setText(i,0,layout->Table_fields->text(i,0));
				Table_dict_fields->setText(i,1,layout->Table_fields->text(i,1));
				Table_dict_fields->setText(i,2,layout->Table_fields->text(i,2));
				Table_dict_fields->setText(i,3,layout->Table_fields->text(i,3));
			}
	}
}
