/***************************************************************************
                          dialog_dictionary_layout.cpp  -  description
                             -------------------
    begin                : Thu Nov 1 2001
    copyright            : (C) 2001 by Denis Lackovic
    email                : delacko@fly.srk.fer.hr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <string.h>
#include <stdio.h>


#include <qfile.h>
#include <qstring.h>
#include<iostream.h>
#include <qlineedit.h>
#include <qbutton.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qstringlist.h>
#include <qmessagebox.h>




#include <qlist.h>
#include "create_dictionary.h"
//#include "dialog_create_dictionary.h"
#include "dialog_dictionary_layout.h"
#include "additional_functions.h"



void dialog_dl::on_field_add(){


	int i;
	int nr=Table_fields->numRows();
	QString fName=LE_field_name->text();
	QString fType=CB_field_type->currentText();
	QString iName=LE_index_name->text();
	QString iType=CB_index_type->currentText();


	if (fName.length()!=0){
		if(CxB_index->isChecked()) {
			if (iName.length()!=0){
				Table_fields->setNumRows(nr+1);
				Table_fields->setText(nr,3,iType+" "+iName);
				CxB_index->setChecked(0);
			}
			else {
				QMessageBox::information( this, "Error creating index",   "You have to name index if you want to make it.", QMessageBox::Ok );
				return;
			}
		}

		for (i=0; i<nr;i++){
			if(Table_fields->text(i,0)==fName){
				QMessageBox::information( this, "Error adding field",   "You cannot have two fields of the same name in dictionary.", QMessageBox::Ok );
				return;
			}
		}

		Table_fields->setNumRows(nr+1);
		Table_fields->setText(nr,0,fName);
		Table_fields->setText(nr,1,fType);
	}
	else {
		QMessageBox::information( this, "Error creating field",   "You have to name field if you want to use it.", QMessageBox::Ok );
		return;
	}

	if(CxB_primary_key->isChecked()) {
		Table_fields->setText(nr,2,"Primary key");
		CxB_primary_key->setChecked(0);

	}

}

void dialog_dl::on_field_down(){
	
	int cR=Table_fields->currentRow();
	
	if (cR<Table_fields->numRows()-1) {
		Table_fields->swapRows(cR,cR+1);

		Table_fields->setCurrentCell(cR,0);
		Table_fields->setCurrentCell(cR,1);
		Table_fields->setCurrentCell(cR,2);
		Table_fields->setCurrentCell(cR,3);


		Table_fields->setCurrentCell(cR+1,0);
		Table_fields->setCurrentCell(cR+1,1);
		Table_fields->setCurrentCell(cR+1,2);
		Table_fields->setCurrentCell(cR+1,3);

		Table_fields->setCurrentCell(cR+1,0);
	}
	

}

void dialog_dl::on_field_up(){
	int cR=Table_fields->currentRow();
	
	if (cR>0) {
		Table_fields->swapRows(cR,cR-1);

		Table_fields->setCurrentCell(cR,0);
		Table_fields->setCurrentCell(cR,1);
		Table_fields->setCurrentCell(cR,2);
		Table_fields->setCurrentCell(cR,3);

		Table_fields->setCurrentCell(cR-1,0);
		Table_fields->setCurrentCell(cR-1,1);
		Table_fields->setCurrentCell(cR-1,2);
		Table_fields->setCurrentCell(cR-1,3);
		
		Table_fields->setCurrentCell(cR-1,0);
	}
	



}

void dialog_dl::on_field_delete(){
	int cR=Table_fields->currentRow();
	int nR =Table_fields->numRows();


	QStringList name;
	QStringList type;
	QStringList key;
	QStringList index;
	int i;

	for (i=0; i< nR;i++){
		if (i!=cR){
			name.append(Table_fields->text(i,0));
			type.append(Table_fields->text(i,1));
			key.append(Table_fields->text(i,2));
			index.append(Table_fields->text(i,3));
		}
	}
	Table_fields->setNumRows(nR-1);
	
	for(i=0; i< nR-1;i++){
		Table_fields->setText(i,0,name[i]);
		Table_fields->setText(i,1,type[i]);
		Table_fields->setText(i,2,key[i]);
		Table_fields->setText(i,3,index[i]);
	}
}

void dialog_dl::on_create_dictionary_type(){
	QString fN = Table_fields->text(0,0);
	QString fT = Table_fields->text(0,1);
	QString tN=LE_type_name->text();
	
	if( fN.length()==0 || fT.length()==0){
		QMessageBox::information( this, "Error in dictionary type",   "At least one type has to be defined for dictionary to be created (click on add when you create field).", QMessageBox::Ok );                                    			
		return;
	}
	if( tN.length()==0){
		QMessageBox::information( this, "Error in naming new type of dixtionary",   "You have to name new tipe of dictionary.", QMessageBox::Ok );                                    			
		return;
	}
	accept();
}
