#!/usr/bin/perl -w
use strict;
use LWP::Simple;
use Pg;
my $conninfo;
my $version;
my $packname;
my $isConnected=0;

my $conn;
my $status;




sub parse_and_insert_po_file{
	my ($file,$conninfo)=@_;

	if ($isConnected==0){
		$conn = Pg::connectdb($conninfo);
		$status = $conn->status;
		if($status){
			print "ovo ne valja ".$conn->errorMessage."\n";
			exit(1);
		}
		$isConnected=1;
	}
	my $content="";
	open(FL,"$file");
	my @lns;
	my $appname="";
	@lns=<FL>;
	foreach(@lns){
			if(m/"Project-Id-Version: (.*)[ \t-]([0-9]+.*)\\n"/){
#				print "ime aplikacije: $1, $2\n";
				$appname=$1;
			}
		$content.=$_;
	}
	close(FL);

	if(length($appname)>0){
		$appname=~s/'/''/;
		$content=~s/'/''/;
		my $insert="select application_insert_new_po('$appname','$content');";
		#	my $insert="insert into application(applicationname,application_po_file) values($appname,$content)";
		my $result = $conn->exec($insert);

		#	print "\n\nrezultat:\n$result,aplikacija: $appname\n";
		#	print "\n--------------------------------------------\n";
	}
	#print "$content";
#	print "imamo $file\n";

	system("./importPo \"englishcroatianlocalization\" \"$conninfo\" \"$file\"  ");
}

sub get_po_files{
	my ($dir,$f,$pf)=@_;
	my $file;
	
	foreach $file (@{$f}){
		if (-f "$dir/$file"){
			push @{$pf},"$dir/$file";
		}
		elsif (-d "$dir/$file"){
			opendir (DIR, "$dir/$file");
			my @nf= grep((!/^(\.\.|\.)/), readdir(DIR));
			get_po_files("$dir/$file",\@nf,$pf);
		}
	}
}



#MAIN


####################### setting server information
#writing server information that will be to connect to postgresql server
my $host="laki.lejmer.hr";
my $port=5432;
my $dbname="delacko";
my $user="delacko";
my $password="";


#host MUST exist 
$conninfo="host=$host";
if(length($port)>0){
	$conninfo.=" port=$port";
}
if(length($dbname)>0){
	$conninfo.=" dbname=$dbname";
}
if(length($user)>0){
	$conninfo.=" user=$user";
}
if(length($password)>0){
	$conninfo.=" password=$password";
}
#first we wil connect to database
#####################################################################



my $dir=$$;
my $pot;
my $f;
my @doc;

mkdir($dir);

# when  mail arrives it is redirected to file called mail, we move that file
# to temporary directory
`mv mail $dir`;
chdir( $dir);

#opening read filehandle
open(MAIL,"mail");
#opening filelandle for writing, it is used only if this message that holds
#information of new  .pot file

my @urls;
my @lines=<MAIL>;

my @po_files;

#to avoid overwrite with atttached files named "mail"
mkdir("t"); 
chdir("t");
#uudeview must be installed for this to work
#we are using uudeiew to decode attachments from file, if file has attachments
#than this directory will be scaned for .{.tgz,.tar.gz,.zip,.tbz,.tar.bz2,.po} files
#and each .po file found in archive or alone will be scaned for messages and inserted into database
`uudeview +e.zip.gz.bz2  -i ../mail`;

opendir(DIR,".");
my @tars= grep((!/^(\.\.|\.)/), readdir(DIR));

my $count=1;
print"imamo tarova: " .scalar(@tars)."\n";
if(scalar(@tars)>0){
	# trying to uncompress all the archives (hoping to find .po files in them
	# if they are not of .po type, they are just deleted
	foreach(@tars){
		if(m/(.*\.tar.gz$)/){
			mkdir($count);
			chdir($count);
			`gzip -dc ../$1 | tar xvf -`;
			`rm ../$1`;
			chdir("../");
			$count++;
		}
		if(m/(.*\.tar.bz2$)/){
			mkdir($count);
			chdir($count);
			`bzip2 -dc ../$1 | tar xvf -`;
			`rm ../$1`;
			chdir("../");
			$count++;
		}
		if(m/(.*\.tar.bz$)/){
			mkdir($count);
			chdir($count);
			`bzip2 -dc ../$1 | tar xvf -`;
			`rm ../$1`;
			chdir("../");
			$count++;
		}
		if(m/(.*\.tgz$)/){
			mkdir($count);
			chdir($count);
			`gzip -dc ../$1 | tar xvf -`;
			`rm ../$1`;
			chdir("../");
			$count++;
		}
		if(m/(.*\.tbz$)/){
			mkdir($count);
			chdir($count);
			`bzip2 -dc ../$1 | tar xvf -`;
			`rm ../$1`;
			chdir("../");
			$count++;
		}
		if(m/(.*\.tbz2$)/){
			mkdir($count);
			chdir($count);
			`bzip2 -dc ../$1 | tar xvf -`;
			`rm ../$1`;
			chdir("../");
			$count++;
		}
		if(m/(.*\.zip$)/){
			mkdir($count);
			chdir($count);
			`unzip $1`;
			`rm ../$1`;
			chdir("../");
			$count++;
		}
	}
	close(DIR);
	#now uncompressed we get all .po files in directory (by recursive scaning)
	print "trenutni dir : ".`pwd`."\n";
	chdir("../../");
	opendir(DIRA,"$dir/t");
	my @files= grep((!/^(\.\.|\.)/), readdir(DIRA));
	get_po_files("$dir/t",\@files,\@po_files);

	#for each .po file we insert it into database
	foreach(@po_files){
		parse_and_insert_po_file($_,$conninfo);
	}
	close(DIRA);
	
}
else {
	#if message contains no attachments it is suppoused to contain information
	#of location of .pot file - file is scaned for url of .pot file (something like http://.*.po)
	foreach(@lines){
		if(m/.*(http:\/\/.*\/)(.*)-([0-9]+\.[0-9+].*)(\.pot).*/){
#			print "nasli -$1-\ni -$2-\n-$3-\n";
			push @urls,"$1$2-$3.pot";
			$packname=$2;
			$version=$3;
			$pot="$1$2-$3.pot";
		}
	}
	close(MAIL);
	if(scalar(@urls)>0){
		#if url of .pot file is found we get it and write it down (with litle rewriting of it's headers)
		# so that it could be inserted into database like normal .po file
		$f = get($urls[0]);
		@doc=split("\n",$f);
#		print "\n-dohvat datoteke $pot, imamo linija " .scalar(@doc)."\n-";
		#		print @doc;
		my $line;
		chdir("../../");
		open(OUTPOT,">$dir/temp.pot");

		foreach $line  (@doc){
			if($line =~ m/"Project-Id-Version: PACKAGE VERSION\\n"/){
#				print "u diru " .`pwd`."\n";
				print OUTPOT  "\"Project-Id-Version: $packname $version\\n\"\n"; 
#				print   "\"Project-Id-Version: $packname $version\\n\"\n"; 
			}
			else {
				print OUTPOT  $line."\n"; 
#				print  $line."\n"; 
			}
		}
		close(OUTPOT);
		#now we are inserting .pot file into database
	
		parse_and_insert_po_file("$dir/temp.pot",$conninfo);
	}
}
#`./parse_and_insert_po_file temp.pot`

#after insertion of all needed files temporary directory is removed
`rm -rf \"$dir\";`
#END MAIN

