#include<qstring.h>
#include<qtextcodec.h>
#include<qfile.h>
#include<qlist.h>
#include<qstringlist.h>
#include<qregexp.h>
#include<qmessagebox.h>
#include<qtextstream.h>
#include<qtextcodec.h>
#include<iostream.h>
#include "sqlite.h"
class message{
	public:
		QString comm;  // coment (#. comment)
		QString flag; // which type of translation is it (fuzzy, c-format,...)
		QString refNo; //file name and line number from which translation was taken
		QString msgId; //expression to be translated
		QString msgStr; //translation of the expression

		message(QString c, QString f,QString r, QString mi, QString ms){
			comm=c; 
			flag=f; 
			refNo=r;
			msgId=mi;
			msgStr=ms;
		}
		message(){}
		~message(){}
		void reset(){
			comm="";
			flag="";
			refNo=""; 
			msgId="";
			msgStr="";
		}
};
int parse_po_file(QList<message> &messages,QString fileName){
	QFile importFile(fileName);

	//these regexps are used to recognize type of translation
	QRegExp begMsgid("^msgid[ \t]\"\"");
	QRegExp begMsgsrt("^msgstr[ \t]\"\"");
	QRegExp text("^\".*\"");
	QRegExp comment("^#\\..*");
	QRegExp ref("^#:[ \t].*");
	QRegExp flag("^#, .*");
	QRegExp refMsgid("^msgid \".*\"");
	QRegExp refMsgstr("^msgstr \".*\"");
	QRegExp othMsgid("^#~ msgid \".*\"");
	QRegExp othMsgstr("^#~ msgstr \".*\"");
	QRegExp othText("^#~ \".*\"");



	message *m = new message;
	m->reset();

	//parsing is done in a finitive state machine
	int state=1; 
	if ( importFile.open(IO_ReadOnly) ) {  

		QTextStream t( &importFile );  
		QTextCodec *codec;
		codec=QTextCodec::codecForName("UTF-8");
		t.setCodec(codec);

		QString s;
		//file is read line by line, and on basis of input (with
		//little help of regexps) states of finitive state machine are changed.
		//All informations are saved in class QList<message> list.
		while ( !t.eof() ) {     
			s = t.readLine();

			if (state==1){
				if (s.find(begMsgid)!=-1){
					m->msgId="NEW PROJECT";
					state=2;
				}
			}
			else if(state==2){
				if (s.find(begMsgsrt)!=-1){
					state=3;
				}
				else {
					m->reset();
				}
			}
			else if(state==3){
				if (s.find(text)!=-1){
					m->msgStr=s.mid(1,s.findRev("\"")-1); 
					state=4;
				}
				else {
					messages.append(new message(m->comm,m->flag,m->refNo,m->msgId,m->msgStr));
					m->reset();
					state=5;
				}
			}
			else if(state==4){
				if (s.find(text)!=-1){
					m->msgStr+="\n"+s.mid(1,s.findRev("\"")-1); 
				}
				else {
					messages.append(new message(m->comm,m->flag,m->refNo,m->msgId,m->msgStr));
					m->reset();
					state=5;
				}
			}
			else if(state==5){
				if (s.find(ref)!=-1){
					m->refNo=s.mid(3,s.length()-1);
					state=7;
				}
				else if (s.find(othMsgid)!=-1){
					m->msgId=s.mid(10,s.findRev("\"")-10);
					state=11;
				}
				else if (s.find(comment)!=-1){
					m->comm=s.mid(2,s.length()-2);
					state=6;
				}
				else if (s.find(flag)!=-1){
					m->flag=s.mid(3,s.length()-1);
					state=51;
				}
				else {
					m->reset();
					state=5;
				}
			}
			else if(state==51){
				if (s.find(othMsgid)!=-1){
					m->msgId=s.mid(10,s.findRev("\"")-10);
					state=11;
				}
				else {
					m->reset();
					state=5;
				}
			}
			else if(state==6){
				if (s.find(ref)!=-1){
					m->refNo=s.mid(3,s.length()-1);
					state=7;
				}

				else if (s.find(comment)!=-1){
					m->comm+="\n"+s.mid(2,s.length()-2);
				}
				else if (s.find(othMsgid)!=-1){
					m->comm=s.mid(8,s.length()-1);
					state=11;
				}
				else {
					m->reset();
					state=5;
				}
			}
			else if(state==7){
				if (s.find(ref)!=-1){
					m->refNo+="\n"+s.mid(3,s.length()-1);
				}
				else if (s.find(flag)!=-1){
					m->flag=s.mid(3,s.length()-1);
					state=8;
				}
				else if (s.find(refMsgid)!=-1){
					m->msgId=s.mid(7,s.findRev("\"")-7);
					state=9;
				}
				else {
					m->reset();
					state=5;
				}
			}
			else if(state==8){
				if (s.find(refMsgid)!=-1){
					m->msgId=s.mid(7,s.findRev("\"")-7);
					state=9;
				}
				else {
					m->reset();
					state=5;
				}
			}
			else if(state==9){
				if (s.find(text)!=-1){
					m->msgId+="\n"+s.mid(1,s.findRev("\"")-1);
				}
				else if (s.find(refMsgstr)!=-1){
					m->msgStr=s.mid(8,s.findRev("\"")-8);
					state=10;
				}
				else {
					m->reset();
					state=5;
				}
			}
			else if(state==10){
				if (s.find(text)!=-1){
					m->msgStr+="\n"+s.mid(1,s.findRev("\"")-1);
				}
				else {
					messages.append(new message(m->comm,m->flag,m->refNo,m->msgId,m->msgStr));
					m->reset();
					state=5;
				}
			}
			else if(state==11){
				if (s.find(othText)!=-1){
					m->msgId+="\n"+s.mid(4,s.findRev("\"")-4);
				}
				else if (s.find(othMsgstr)!=-1){
					m->msgStr=s.mid(11,s.findRev("\"")-11);
					state=12;
				}
				else {
					m->reset();
					state=5;
				}
			}
			else if(state==12){
				if (s.find(othText)!=-1){
					m->msgStr+="\n"+s.mid(4,s.findRev("\"")-4);
				}
				else {
					messages.append(new message(m->comm,m->flag,m->refNo,m->msgId,m->msgStr));
					m->reset();
					state=5;
				}
			}
		}
		importFile.close();
	}
	else {
		QMessageBox::information( 0, "Error opening import file", "I cannot open file "+ fileName, QMessageBox::Ok );                
		return 1;
	}
}

//this function is used after scaning .po file, and saving it's messages (with
// parse_po_file) It compares message expressions and tries to find
// translation in database. If it find's them it write's them in output, else
// previous scaned translations are used (if there are any)
int export_po_file(QList<message> &messages,QString fileName){

	QFile exportFile(fileName);

	QStringList lines;


	int i;
	QListIterator<message> it(messages);
	QStringList a;

	for ( ; it.current(); ++it ) {    
		message *m = it.current();

		//preparing translations, expressions, etc. for writting to file
		if (m->msgId=="NEW PROJECT"){
			lines.append("msgid \"\"\nmsgstr \"\"\n");
			a=a.split("\n",m->msgStr,TRUE);
			for (i=0; i<a.count(); i++){
				lines.append("\""+a[i]+"\"\n");
			}
			lines.append("\n");
		}
		else {
			if(m->refNo.length()!=0){
				if(m->comm.length()!=0){
					a=a.split("\n",m->comm,TRUE);
					if(a[0].length()==0){
						lines.append("#.\n");
					}
					else {
						lines.append("#."+a[0]+"\n");
					}
					for (i=1; i<a.count(); i++){
						lines.append("#."+a[i]+"\n");
					}
				}

				a=a.split("\n",m->refNo);
				for (i=0; i<a.count(); i++){
					lines.append("#: " +a[i]+"\n");
				}
				if (m->flag.length()!=0) lines.append("#, "+m->flag+"\n");

				a=a.split("\n",m->msgId,TRUE);

				if(a[0].length()==0){
					lines.append("msgid \"\"\n");
				}
				else {
					lines.append("msgid \""+ a[0]+"\"\n");
				}
				for (i=1; i<a.count(); i++){
					lines.append("\""+a[i]+"\"\n");
				}
				a=a.split("\n",m->msgStr,TRUE);

				if(a[0].length()==0){
					lines.append("msgstr \"\"\n");
				}
				else {
					lines.append("msgstr \"" +a[0]+"\"\n");
				}
				for (i=1; i<a.count(); i++){
					lines.append("\""+a[i]+"\"\n");
				}


			}
			else {
				if(m->comm.length()!=0){
					a=a.split("\n",m->comm,TRUE);
					if(a[0].length()==0){
						lines.append("#.\n");
					}
					else {
						lines.append("#."+a[0]+"\n");
					}
					for (i=1; i<a.count(); i++){
						lines.append("#."+a[i]+"\n");
					}
				}
				if (m->flag.length()!=0) lines.append("#, "+m->flag+"\n");

				a=a.split("\n",m->msgId,TRUE);
				if(a[0].length()==0){
					lines.append("#~ msgid \"\"\n");
				}
				else {
					lines.append("#~ msgid \""+a[0]+"\"\n");
				}
				for (i=1; i<a.count(); i++){
					lines.append("#~ \""+a[i]+"\"\n");
				}
				
				a=a.split("\n",m->msgStr,TRUE);

				if(a[0].length()==0){
					lines.append("#~ msgstr \"\"\n");
				}
				else {
					lines.append("#~ msgstr \"" +a[0]+"\"\n");
				}
				for (i=1; i<a.count(); i++){
					lines.append("#~ \"" +a[i]+"\"\n");
				}
			}
			lines.append("\n");
		}

	}

	if ( exportFile.open(IO_WriteOnly) ) {   

		QTextStream ts(&exportFile);


		//setting codec to utf-8
		QTextCodec *codec;
		codec=QTextCodec::codecForName("UTF-8");
		ts.setCodec(codec);
		
		//writing prepared files
		for ( QStringList::Iterator it = lines.begin(); it != lines.end(); ++it ) {
			QString a=*it;
			ts<<a;
		}
	}
	else         {
		QMessageBox::information( 0, "Error writing to export file",   "I cannot write to export file " + fileName, QMessageBox::Ok );             
	}
	exportFile.close();



}

int import_po_file(QList<message> &messages,QString fileName){

	sqlite *database;
	database=sqlite_open("baza.db", 0,0/* &errmesg*/);

	QRegExp pr("'");

	//here we prepare messagees for sql insert into database
	QListIterator<message> it(messages); 
	for ( ; it.current(); ++it ) {
		message *m = it.current();

		//any "'" in strings that are to be inserted into database is
		//here replaced with "''" to avoid errors (due to sql syntax).
		m->msgId.replace(pr,"''");
		m->msgStr.replace(pr,"''");
		m->comm.replace(pr,"''");
		m->flag.replace(pr,"''");

		if (m->msgStr.length()==0){
			m->msgStr="NULL";
		}
		else {
			m->msgStr="'"+m->msgStr+"'";
		}
		if (m->comm.length()==0){
			m->comm="NULL";
		}
		else {
			m->comm="'"+m->comm+"'";
		}
		if (m->flag.length()==0){
			m->flag="NULL";
		}
		else {
			m->flag="'"+m->flag+"'";
		}
		if (m->msgId.length()==0){
			m->msgId="NULL";
		}
		else {
			m->msgId="'"+m->msgId+"'";
		}


		if (m->msgId!="NEW PROJECT"){	
			QString insert="insert into  englishcroatianlocalization(expression,translation,comment,translationtype) values("+m->msgId+","+m->msgStr+","+m->comm+","+m->flag+");";

			QCString a(insert.utf8());	

		//	sqlite_exec_printf(database,a.data(),0,0,0);
			//			cout <<a.data()<<endl;

		}
	}
}

int main(int argc, char **argv){


	QList<message> messages;
	parse_po_file(messages,"hr.po");
	import_po_file(messages,"hr.po");
	messages.clear();
	parse_po_file(messages,"hr.po");
	export_po_file(messages,"evo.po");

	return 0;
}
